"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
require("./MultiSelectDropdown.css");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
// Import default styles

var MultiSelectDropdown = function MultiSelectDropdown(_ref) {
  var items = _ref.items,
    _ref$maxVisibleItems = _ref.maxVisibleItems,
    maxVisibleItems = _ref$maxVisibleItems === void 0 ? 1 : _ref$maxVisibleItems,
    onSelectionChange = _ref.onSelectionChange,
    _ref$isMulti = _ref.isMulti,
    isMulti = _ref$isMulti === void 0 ? true : _ref$isMulti,
    _ref$customClassNames = _ref.customClassNames,
    customClassNames = _ref$customClassNames === void 0 ? {} : _ref$customClassNames,
    _ref$placeholderText = _ref.placeholderText,
    placeholderText = _ref$placeholderText === void 0 ? 'Select items' : _ref$placeholderText,
    _ref$selectAllText = _ref.selectAllText,
    selectAllText = _ref$selectAllText === void 0 ? 'Select All' : _ref$selectAllText,
    _ref$searchPlaceholde = _ref.searchPlaceholderText,
    searchPlaceholderText = _ref$searchPlaceholde === void 0 ? 'Search...' : _ref$searchPlaceholde;
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    dropdownVisible = _useState2[0],
    setDropdownVisible = _useState2[1];
  var _useState3 = (0, _react.useState)(''),
    _useState4 = _slicedToArray(_useState3, 2),
    searchTerm = _useState4[0],
    setSearchTerm = _useState4[1];
  var _useState5 = (0, _react.useState)(false),
    _useState6 = _slicedToArray(_useState5, 2),
    showCount = _useState6[0],
    setShowCount = _useState6[1];
  var _useState7 = (0, _react.useState)(maxVisibleItems),
    _useState8 = _slicedToArray(_useState7, 2),
    adjustedMaxVisibleItems = _useState8[0],
    setAdjustedMaxVisibleItems = _useState8[1];
  var selectedItemsRef = (0, _react.useRef)(null);
  var dropdownRef = (0, _react.useRef)(null);
  var normalizeItems = function normalizeItems(items) {
    return items.map(function (item, index) {
      return typeof item === 'string' ? {
        id: index,
        name: item,
        value: item,
        checked: false
      } : {
        id: index,
        name: item.name,
        value: item.value,
        checked: false
      };
    });
  };
  var _useState9 = (0, _react.useState)(normalizeItems(items)),
    _useState10 = _slicedToArray(_useState9, 2),
    internalItems = _useState10[0],
    setInternalItems = _useState10[1];
  var calculate = (0, _react.useCallback)(function () {
    if (!selectedItemsRef.current || !dropdownRef.current) return;
    var containerWidth = dropdownRef.current.offsetWidth;
    var itemWidths = Array.from(selectedItemsRef.current.children).filter(function (child) {
      return !child.classList.contains('msd-item-count');
    }).map(function (child) {
      return child.offsetWidth;
    });
    var totalWidth = 0;
    var visibleCount = 0;
    for (var i = 0; i < itemWidths.length; i++) {
      totalWidth += itemWidths[i];
      if (totalWidth > containerWidth) {
        break;
      }
      visibleCount++;
    }
    setShowCount(totalWidth > containerWidth);
    setAdjustedMaxVisibleItems(Math.min(visibleCount, maxVisibleItems));
  }, [maxVisibleItems]);
  (0, _react.useEffect)(function () {
    calculate();
  }, [internalItems, dropdownVisible, calculate]);
  var filteredItems = (0, _react.useCallback)(function () {
    return internalItems.filter(function (item) {
      return item.name && typeof item.name === 'string' && item.name.toLowerCase().includes(searchTerm.toLowerCase());
    });
  }, [internalItems, searchTerm]);
  var toggleDropdown = function toggleDropdown() {
    setDropdownVisible(function (prev) {
      return !prev;
    });
  };
  var getSelectedValue = (0, _react.useCallback)(function (selectedItem) {
    if (isMulti) {
      setInternalItems(function (prevItems) {
        var updatedItems = prevItems.map(function (item) {
          return item.id === selectedItem.id ? _objectSpread(_objectSpread({}, item), {}, {
            checked: !item.checked
          }) : item;
        });
        emitSelection(updatedItems);
        calculate();
        return updatedItems;
      });
    } else {
      setInternalItems(function (prevItems) {
        var updatedItems = prevItems.map(function (item) {
          return item.id === selectedItem.id ? _objectSpread(_objectSpread({}, item), {}, {
            checked: true
          }) : _objectSpread(_objectSpread({}, item), {}, {
            checked: false
          });
        });
        emitSelection(updatedItems);
        calculate();
        return updatedItems;
      });
    }
  }, [isMulti]);
  var emitSelection = function emitSelection(updatedItems) {
    var selectedItems = updatedItems.filter(function (item) {
      return item.checked;
    }).map(function (item) {
      return item.value;
    });
    if (onSelectionChange) {
      setTimeout(function () {
        onSelectionChange(selectedItems); // Defer the parent's state update.
      }, 0);
      // onSelectionChange(selectedItems);
    }
  };
  var selectAllItems = (0, _react.useCallback)(function () {
    if (isMulti) {
      var filtered = filteredItems();
      var allSelected = filtered.every(function (item) {
        return item.checked;
      });
      setInternalItems(function (prevItems) {
        var updatedItems = prevItems.map(function (item) {
          return filtered.some(function (filteredItem) {
            return filteredItem.id === item.id;
          }) ? _objectSpread(_objectSpread({}, item), {}, {
            checked: !allSelected
          }) : item;
        });
        emitSelection(updatedItems);
        calculate();
        return updatedItems;
      });
    }
  }, [filteredItems, isMulti]);
  var removeItem = (0, _react.useCallback)(function (itemToRemove, event) {
    event.stopPropagation();
    setInternalItems(function (prevItems) {
      var updatedItems = prevItems.map(function (item) {
        return item.id === itemToRemove.id ? _objectSpread(_objectSpread({}, item), {}, {
          checked: false
        }) : item;
      });
      emitSelection(updatedItems);
      return updatedItems;
    });
  }, []);
  (0, _react.useEffect)(function () {
    var handleClickOutside = function handleClickOutside(event) {
      if (dropdownRef.current && !dropdownRef.current.contains(event.target)) {
        setDropdownVisible(false);
      }
    };
    document.addEventListener('mousedown', handleClickOutside);
    return function () {
      document.removeEventListener('mousedown', handleClickOutside);
    };
  }, []);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "msd-container ".concat(customClassNames.container || ''),
    ref: dropdownRef
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "msd-btn ".concat(customClassNames.button || ''),
    onClick: toggleDropdown
  }, internalItems.filter(function (item) {
    return item.checked;
  }).length === 0 ? /*#__PURE__*/_react["default"].createElement("span", {
    className: "msd-placeholder ".concat(customClassNames.placeholder || '')
  }, placeholderText || 'Select items') : /*#__PURE__*/_react["default"].createElement("div", {
    className: "msd-selected-items ".concat(customClassNames.selectedItems || ''),
    ref: selectedItemsRef
  }, internalItems.filter(function (item) {
    return item.checked;
  }).slice(0, adjustedMaxVisibleItems).map(function (item, index) {
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: "msd-selected-item ".concat(customClassNames.selectedItem || ''),
      key: item.id + index
    }, item.name, isMulti && /*#__PURE__*/_react["default"].createElement("span", {
      className: "msd-close-icon ".concat(customClassNames.closeIcon || ''),
      onClick: function onClick(e) {
        return removeItem(item, e);
      }
    }, "x"));
  }), internalItems.filter(function (item) {
    return item.checked;
  }).length > adjustedMaxVisibleItems && /*#__PURE__*/_react["default"].createElement("span", {
    className: "msd-item-count ".concat(customClassNames.itemCount || '')
  }, "+", internalItems.filter(function (item) {
    return item.checked;
  }).length - adjustedMaxVisibleItems)), /*#__PURE__*/_react["default"].createElement("span", {
    className: "msd-caret ".concat(dropdownVisible ? 'msd-caret-open' : '', " ").concat(customClassNames.caret || '')
  })), dropdownVisible && /*#__PURE__*/_react["default"].createElement("div", {
    className: "msd-dropdown-list ".concat(customClassNames.dropdownList || '')
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "msd-search-bar ".concat(customClassNames.searchBar || '')
  }, /*#__PURE__*/_react["default"].createElement("input", {
    type: "text",
    value: searchTerm,
    onChange: function onChange(e) {
      return setSearchTerm(e.target.value);
    },
    placeholder: searchPlaceholderText || 'Search ...',
    className: "msd-search-input ".concat(customClassNames.searchInput || '')
  })), isMulti && /*#__PURE__*/_react["default"].createElement("div", {
    className: "msd-dropdown-item ".concat(customClassNames.dropdownItem || '')
  }, /*#__PURE__*/_react["default"].createElement("label", {
    className: "msd-label ".concat(customClassNames.label || '')
  }, /*#__PURE__*/_react["default"].createElement("input", {
    type: "checkbox",
    checked: filteredItems().every(function (item) {
      return item.checked;
    }),
    onChange: selectAllItems
  }), selectAllText || "Select All")), filteredItems().map(function (item) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "msd-dropdown-item ".concat(customClassNames.dropdownItem || ''),
      key: item.id
    }, /*#__PURE__*/_react["default"].createElement("label", {
      className: "msd-label ".concat(customClassNames.label || '')
    }, isMulti ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("input", {
      type: "checkbox",
      checked: item.checked,
      onChange: function onChange() {
        return getSelectedValue(item);
      }
    })) : /*#__PURE__*/_react["default"].createElement("span", {
      className: "msd-single-select-item ".concat(item.checked ? 'msd-selected' : '', " ").concat(customClassNames.singleSelectItem || ''),
      onClick: function onClick() {
        return getSelectedValue(item);
      }
    }, item.name), isMulti ? item.name : ''));
  })));
};
var _default = exports["default"] = MultiSelectDropdown;